declare("Turrets", {version = '1.92'})
--[[
--
-- TODO: It currently supports only gems 
-- turrets , must add support for swarms
-- made with help from lisa, i added defend.ogg and some other stuff
--
--]]

local defaultrun = 90
--local multiplier = 5
local navcompinstalled = true
local tubolockinstalled = true
local turbohopinstalled = true
local turrets = 0
local lastturret = lastturret or 1
local desiredturret = desiredturret or 1
local DefendCount = 0
local passenger = passenger or false
local defending = false
local runningnow = false
local DefendLoop = Timer()
local TurretsTimer = Timer()
local DefendLoopTimeL = 300
local DefendLoopTimeH = 2000
local ship = true
local turret = false
local debugon = false
local MinDistance = 3200
local soundon = true
local soundlevel = 10 
local wasdefending = false
LisaStuff = {}

-------------------------------------------------------------	
-- Call back function
-------------------------------------------------------------	
function turretcallback(err,result)
	if err then 
		--if not (err == 29) then
		--if err == 31 then return end
			if err == 31 then
				desiredturret = desiredturret + 1
				enterturret() -- Just jump into the turret
			end
			if result then 
				print("XResult: "..result) 
			end
			if err then 
				if (err == 29) and (DefendLoopTimeL < 3000) then 
					DefendLoopTimeL = DefendLoopTimeL + 20
					HUD:PrintSecondaryMsg("\127cd5cc0+10    Set at: "..DefendLoopTimeL)
					DefendCount = 0
					return
				end
				print("XError: "..err) 
			end
	end
end

-------------------------------------------------------------	
-- turret enter turret function
-------------------------------------------------------------	
function enterturret(_)
	if debugon then debugstatus("enterturret") end
	fireoff() -- Stop shooting...
	UnregisterEvent(enterturret, "SHIP_SPAWN_CINEMATIC_FINISHED")
	UnregisterEvent(enterturret, "ENTERED_STATION")
	UnregisterEvent(enterturret, "PLAYER_UPDATE_STATS")
	if desiredturret > turrets then desiredturret = 1 end -- Jump back to 1 if higher than num turrets.
	if desiredturret < 1 then desiredturret = turrets end -- Jump back to 1 if higher than num turrets.
	if turrets < 1 then return end -- No turrets
	if turrets < desiredturret then return end -- No such turret
	HUD:PrintSecondaryMsg("\127cd5c00Turret "..desiredturret.."\127o")
	if GetStationTurretInfo(desiredturret).itemid == nil then 
		print("\127cd5c00got nil from the turret info") 
		return
	else
	PurchaseMerchandiseItem(GetStationTurretInfo(desiredturret).itemid,1,turretcallback)
	end
end

-------------------------------------------------------------	
-- main function
-------------------------------------------------------------	
function turretthing(_,mydata)
	if debugon then debugstatus("turretthing") end
	if turrets < 1 then return end -- No turrets I'm otta here...
	
	if mydata then -- Specified the turret number
		desiredturret = mydata[1]
		if desiredturret > turrets then desiredturret = 1 end -- Jump back to 1 if higher than num turrets.
		if desiredturret < 1 then desiredturret = turrets end -- Jump back to 1 if higher than num turrets.
		if turrets < desiredturret then return end -- No such turret
	end
	lastturret = desiredturret  -- Get what turret they want

	if not passenger and ship then 
		if debugon then print("1 x") end -- In your own ship, turret to turret
		enterturret() -- Just jump into the turret
		return
	end

	if not passenger and turret then -- You are passenger in a turret
		turretsactivate() -- Get out of the turret.
		if debugon then print("2 x") end
		RegisterEvent(enterturret, "SHIP_SPAWN_CINEMATIC_FINISHED")
		return
	end

	if passenger and ship then 
		if debugon then print("3 x") end -- 
		enterturret() -- Just jump into the turret
		return
	end

	if passenger and turret then -- You are already in a turret, in dent
		if debugon then print("4 x") end
		RegisterEvent(enterturret, "ENTERED_STATION")
		turretsactivate() 
		return
	end
end

-------------------------------------------------------------	
-- Turn off fire
-------------------------------------------------------------	
function fireon()
		gkinterface.GKProcessCommand("+Shoot2 1") -- Fire turrets!
end

-------------------------------------------------------------	
-- Turn off fire
-------------------------------------------------------------	
function fireoff()
	gkinterface.GKProcessCommand("+Shoot2 0") -- Stop Fire turrets!
end

-------------------------------------------------------------	
-- Activate
-------------------------------------------------------------	
function turretsactivate()
	gkinterface.GKProcessCommand("Activate")
end

-------------------------------------------------------------	
-- Turret enable
-------------------------------------------------------------	
function turretenable() -- Re enable the /tur command.
	RegisterUserCommand ("tur", turretthing)
end

-------------------------------------------------------------	
-- Target Aquire
-------------------------------------------------------------	
function targetaquire() -- target closest enamy, or front
	local tvalid = false
-- 	--gkinterface.GKProcessCommand("RadarNextNearestEnemy")
	gkinterface.GKProcessCommand("RadarNextFrontEnemy")
	local charid1 = RequestTargetStats()
	local distance1 = GetPlayerDistance(charid1) or 10000
	
	if distance1 < MinDistance/4 then
		return true
	end
	
	gkinterface.GKProcessCommand("RadarNextNearestEnemy")
	local charid2 = RequestTargetStats()
	local distance2 = GetPlayerDistance(charid2) or 10000
	
	if (distance2 > MinDistance) then 
		if (distance2 > MinDistance) and (distance2-500< MinDistance) then
			--print("you are too close... back away!")
			--local msg ="say_sector BACK OFF!  Defenses are running and you are getting too close."
			--gkinterface.GKProcessCommand(msg)

		end
		return false
	else
		return true
	end
end

-------------------------------------------------------------	
-- Turret reload
-------------------------------------------------------------	
function turretreload(event,mydata) -- Reload!
if mydata["msg"]=="<CLICK!> Out of missiles!" then 
	if ship then return end -- Don't try to reload in a normal ship.
	if debugon then debugstatus("TurretReload") end
		gkinterface.GKProcessCommand("Activate") -- Get out of the turret.
 		if passenger then
			RegisterEvent(enterturret, "PLAYER_UPDATE_STATS")
		else
			enterturret()
		end
	end
end

-------------------------------------------------------------	
-- Fire for some time, then activate next turret
-------------------------------------------------------------	
function turretfire() -- Shooting
	if turrets > 1 or ship then 
		desiredturret = desiredturret + 1
		turretthing() 
	end -- Jump into next turret
	DefendLoop:SetTimeout(DefendLoopTimeL,defendme)
end

-------------------------------------------------------------	
-- Go into defending mode; target nearest enemy and fire gems.
-------------------------------------------------------------	
function defend(_,data)
	if debugon then debugstatus("defend") end
	if turrets < 1 then 
		Turrets.defending = false
		--wasdefending = false
		fireoff()
		return 
	end -- No turrets
	
  if defending then 
		defending = false
		--wasdefending = false
		DefendLoop:Kill()
		fireoff()
		runningnow = false
		if passenger then
			print("\127cd5c00Defense Turrets de-activated\127o") 
		else 
			HUD:PrintSecondaryMsg("\127cd5c00Defense Turrets de-activated\127o")
		end
		
		desiredturret = 1 -- Reset this
		return
	else
		defending = true
		gkinterface.GKProcessCommand("targetnone")  -- Un-target when activating...
		HUD:PrintSecondaryMsg("\127cd5c00Defense Turrets Activated!")
		if passenger then
			print("\127cd5c00Defense Turrets Activated.")
			turretthing() -- Jump into next turret
		end
		defendme()
	end
end

-------------------------------------------------------------	
-- Go into defending mode; target nearest enemy and fire gems.
-------------------------------------------------------------	
function defendme()

	if turrets < 1 then 
		--defending = false
		fireoff()
		return 
	end -- No turrets
	
	local health = GetPlayerHealth(GetCharacterID())
	--if runningnow then print("running") else print("Not running") end
	--if not health == -1 and health < defaultrun and runningnow == false  then 
	if health > 0 and health < defaultrun and runningnow == false  then
		if turret and not passenger then -- Get out of turret
			turretsactivate()
		end

		print("Shields down!  Time to Run!!!  Ship at"..health.."%")
		runningnow = true
		if tubolockinstalled then
			gkinterface.GKProcessCommand("turbolock") -- Start turbo
		end
		if navcompinstalled then
			gkinterface.GKProcessCommand("evade") -- Turn on evade
		end
		if turbohopinstalled then
			gkinterface.GKProcessCommand("turbohop") -- Turn on turbohop
		end
	end
	
	if debugon then debugstatus("defendme") end
	
	if not (targetaquire()) then 
			fireoff() --Nothing to shoot at...
		if defending and passenger and not turret then turretthing() end -- Get back in a turret!
			
		if soundon then 
			gksound.GKPlaySound("DefendMode", soundlevel) 
		else
			HUD:PrintSecondaryMsg("\127cd5c00Defend is ACTIVE!")
		end
		if turret and not passenger then -- Get out of turret
			turretsactivate()
		end
		DefendLoop:SetTimeout(DefendLoopTimeH,defendme)
		return
	end
	
	--if debugon then debugstatus("defendme2") end
	
	DefendCount = DefendCount +1
	if DefendCount >= 20 then
		DefendCount = 0
		DefendLoopTimeL = DefendLoopTimeL - 8
		HUD:PrintSecondaryMsg("\127cd5cc0-8    Set at: "..DefendLoopTimeL)
	end
	
	if turret then 
		local mygun = GetInventoryItemName(GetActiveShipItemIDAtPort(desiredturret+2))
		--print("Weapon is: "..mygun)
		--Gemini Homing Missile Turret
		--string.match(Name, 'Gemini')
		--print("Weapon: "..mygun)
		if debugon then debugstatus("defendme3") end
		fireon() -- Start shooting
		--local swarms = false
		if mygun and string.match(mygun, 'Gemini') then
			DefendLoop:SetTimeout(40,turretfire) -- Short delay for gems
		else
			DefendLoop:SetTimeout(1800,turretfire) -- 2 sec delay for all swarms to fire
			--turretfire() -- short delay for gems
		end
	else 
		turretthing() -- get in a turret
	end
	
end

-------------------------------------------------------------	
-- Debug info goes here.
-------------------------------------------------------------	
function debugstatus(mydata)
	mydata = mydata or "-blank-"
	local msg = "\127ffffff"..mydata.."  "
	msg = msg.."Num Turrets: "..turrets.."  "
	msg = msg.."Desired Turret: "..desiredturret.."  "
	if ship then msg = msg.."\12700cf10" else msg = msg.."\127ff1010" end
	msg = msg.."Ship "
	if turret then msg = msg.."\12700cf10" else msg = msg.."\127ff1010" end
	msg = msg.."Turret "
	if passenger then msg = msg.."\12700cf10" else msg = msg.."\127ff1010" end
	msg = msg.."passenger "
	if defending then msg = msg.."\12700cf10" else msg = msg.."\127ff1010" end
	msg = msg.."Defending "
	if wasdefending then msg = msg.."\12700cf10" else msg = msg.."\127ff1010" end
	msg = msg.."WasDefending "
	print(msg)
end

-------------------------------------------------------------	
-- event hud hide when jumping
-------------------------------------------------------------	
function EventHudHide(event, mydata)
	if defending then 
		wasdefending = true
		DefendLoop:Kill()
		fireoff()
	else
		wasdefending = false
	end
	if debugon then debugstatus("HudHide") end
end

	-------------------------------------------------------------	
-- event handler for hud show
-------------------------------------------------------------	
function EventHudShow(event, mydata)
	fireoff()
	ship = false
	turret = false
	if mydata == "ship" then 
		ship = true
		TurretsTimer:SetTimeout(800,getnumturrets)
	end
	if mydata == "turret" then 
		turret = true
	end
	if debugon then debugstatus("HudShow") end
	if wasdefending then 
		defending = true 
		targetaquire()
		DefendLoop:SetTimeout(DefendLoopTimeL,defendme)
		wasdefending = false
	end
end

-------------------------------------------------------------	
-- event handler for ship spawning
-------------------------------------------------------------	
function EventSpawn(event, mydata)
	passenger = false
	turrets = GetNumStationTurrets() 
	if debugon then debugstatus("EventSpawn") end
end

-------------------------------------------------------------	
-- event handler for enter station
-------------------------------------------------------------	
function EventStation(event, mydata)
	passenger = true
	ship = true
	turret = false
	turrets = GetNumStationTurrets()
	if debugon then debugstatus("EventStation") end
	if defending then
		DefendLoop:SetTimeout(DefendLoopTimeH,defendme)
	end
end

-------------------------------------------------------------	
-- Toggle debug on and off
-------------------------------------------------------------	
function debugtoggle()
	debugon = not debugon
	if debugon then print("debug on") else print("debug off") end
end

-------------------------------------------------------------	
-- Get num turrets
-------------------------------------------------------------	
function getnumturrets()
	turrets = GetNumStationTurrets()
	if debugon then debugstatus("getnumturrets") end
end

-------------------------------------------------------------	
-- Init Plugin
-------------------------------------------------------------	
function Init()
	UnregisterEvent(Init1, "SECTOR_LOADED")
	gksound.GKLoadSound{soundname="DefendMode", filename="plugins/Turrets/sounds/defend.ogg"};
	getnumturrets()
	RegisterEvent(EventHudShow, "HUD_SHOW")
	RegisterEvent(EventHudHide, "HUD_HIDE")
	RegisterEvent(turretreload, "CHAT_MSG_PRINT")
	RegisterEvent(EventStation, "ENTERED_STATION")
	RegisterEvent(EventSpawn, "SHIP_SPAWN_CINEMATIC_FINISHED")
	print("\127ffffffTurrets Version "..Turrets.version)
end

-------------------------------------------------------------	
-- Init Plugin
-------------------------------------------------------------	
function Init1()
	TurretsTimer:SetTimeout(5000,Init)
end

-------------------------------------------------------------	
-- Commands and events
-------------------------------------------------------------	
RegisterUserCommand ("tur", function() local a = {lastturret + 1}; turretthing(nil, a) end);
RegisterUserCommand ("tur+", function() local a = {lastturret + 1}; turretthing(nil, a) end);
RegisterUserCommand ("tur-", function() local a = {lastturret - 1}; turretthing(nil, a) end);
RegisterUserCommand ("tur1", function() local a = {1}; turretthing(nil, a) end);
RegisterUserCommand ("tur2", function() local a = {2}; turretthing(nil, a) end);
RegisterUserCommand ("tur3", function() local a = {3}; turretthing(nil, a) end);
RegisterUserCommand ("tur4", function() local a = {4}; turretthing(nil, a) end);
RegisterUserCommand ("turx", debugstatus);
RegisterUserCommand ("turd", debugtoggle);
RegisterUserCommand ("tura", targetaquire);
RegisterUserCommand ("defend", defend);
--RegisterEvent(EventStation, "ENTERED_STATION")
--RegisterEvent(EventHudShow, "HUD_SHOW")
--RegisterEvent(EventHudHide, "HUD_HIDE")
--RegisterEvent(EventSpawn, "SHIP_SPAWN_CINEMATIC_FINISHED")
--RegisterEvent(turretreload, "CHAT_MSG_PRINT")
--RegisterEvent(Init, "PLAYER_ENTERED_GAME")
RegisterEvent(Init1, "SECTOR_LOADED")
